com.thinkaurelius.titan.core.schema

## Interface TitanGraphIndex

- All Superinterfaces:
    Namifiable, TitanIndex, TitanSchemaElement
  All Known Implementing Classes:
    TitanGraphIndexWrapper

      public interface TitanGraphIndex
      extends TitanIndex

  A TitanGraphIndex is an index installed on the graph in order to be able to efficiently retrieve graph elements by their properties. A TitanGraphIndex may either be a composite or mixed index and is created via `TitanManagement.buildIndex(String, Class)`.

  This interface allows introspecting an existing graph index. Existing graph indexes can be retrieved via `TitanManagement.getGraphIndex(String)` or `TitanManagement.getGraphIndexes(Class)`.
  Author:
    Matthias Broecheler (me@matthiasb.com)

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `getBackingIndex()` Returns the name of the backing index.
    `PropertyKey[]` | `getFieldKeys()` Returns the indexed keys of this index.
    `Class<? extends com.tinkerpop.blueprints.Element>` | `getIndexedElement()` Returns which element type is being indexed by this index (vertex, edge, or property)
    `SchemaStatus` | `getIndexStatus(PropertyKey key)` Returns the status of this index with respect to the provided `PropertyKey`.
    `String` | `getName()` Returns the name of the index
    `Parameter[]` | `getParametersFor(PropertyKey key)` Returns the parameters associated with an indexed key of this index.
    `boolean` | `isCompositeIndex()` Whether this is a composite index
    `boolean` | `isMixedIndex()` Whether this is a mixed index
    `boolean` | `isUnique()` Whether this is a unique index, i.e.

- - ### Method Detail

    - #### getName

          String getName()

      Returns the name of the index
      Specified by:
        `getName` in interface `Namifiable`
      Returns:

    - #### getBackingIndex

          String getBackingIndex()

      Returns the name of the backing index. For composite indexes this returns a default name. For mixed indexes, this returns the name of the configured indexing backend.
      Returns:

    - #### getIndexedElement

          Class<? extends com.tinkerpop.blueprints.Element> getIndexedElement()

      Returns which element type is being indexed by this index (vertex, edge, or property)
      Returns:

    - #### getFieldKeys

          PropertyKey[] getFieldKeys()

      Returns the indexed keys of this index. If the returned array contains more than one element, its a composite index.
      Returns:

    - #### getParametersFor

          Parameter[] getParametersFor(PropertyKey key)

      Returns the parameters associated with an indexed key of this index. Parameters modify the indexing behavior of the underlying indexing backend.
      Parameters:
        `key` -
      Returns:

    - #### isUnique

          boolean isUnique()

      Whether this is a unique index, i.e. values are uniquely associated with at most one element in the graph (for a particular type)
      Returns:

    - #### getIndexStatus

          SchemaStatus getIndexStatus(PropertyKey key)

      Returns the status of this index with respect to the provided `PropertyKey`. For composite indexes, the key is ignored and the status of the index as a whole is returned. For mixed indexes, the status of that particular key within the index is returned.
      Returns:

    - #### isCompositeIndex

          boolean isCompositeIndex()

      Whether this is a composite index
      Returns:

    - #### isMixedIndex

          boolean isMixedIndex()

      Whether this is a mixed index
      Returns:

Copyright © 2012–2014. All rights reserved.